package se.chalmers.paragon;

public class Atom {

	private Lock lock;
	private ActorList args;

	protected Atom(Lock lock, Actor... args) {
		this.lock = lock;
		this.args = new ActorList(args);
	}
	
	protected Atom(Lock lock, ActorList args) {
		this.lock = lock;
		this.args = args;
	}
	
	public static Atom newAtom(Lock lock, Actor... args){
		return new Atom(lock, args);
	}
	
	public static Atom newAtom(Lock lock, ActorList args){
		return new Atom(lock, args);
	}

	public Lock getLock() {
		return lock;
	}

	public ActorList getArgs() {
		return args;
	}
	
	public boolean isGround() {
		return this.args.isGround();
	}
	
	public String toString() {
	    String res = lock.getNameString();
	    res += args.toString();
	    return res;
	}
}
